Index: src/uk/me/parabola/mkgmap/build/MapBuilder.java
===================================================================
--- src/uk/me/parabola/mkgmap/build/MapBuilder.java	(revision 4737)
+++ src/uk/me/parabola/mkgmap/build/MapBuilder.java	(working copy)
@@ -816,6 +816,22 @@
 			Zoom zoom = map.createZoom(linfo.getLevel(), linfo.getBits());
 
 			for (SourceSubdiv srcDivPair : srcList) {
+				// recalculate preserved status for all points in lines and shapes
+				List<MapShape> shapes = srcDivPair.getSource().getShapes();
+				List<MapLine> lines = srcDivPair.getSource().getLines();
+				shapes.forEach(e -> e.getPoints().forEach(p -> p.preserved(false)));
+				if (zoom.getLevel() == 0 && hasNet) {
+					lines.forEach(e -> e.getPoints().forEach(p -> p.preserved(p.isNumberNode())));	
+				} else {
+					lines.forEach(e -> e.getPoints().forEach(p -> p.preserved(false)));
+				}
+				preserveFirstLast(lines);
+				if (zoom.getResolution() < 24) {
+					preserveHorizontalAndVerticalLines(zoom.getResolution(), shapes);
+				}
+			}
+			
+			for (SourceSubdiv srcDivPair : srcList) {
 				if (mergeShapes && isOverviewComponent) {
 					mergeShapesFirst(srcDivPair, zoom);
 				}
@@ -928,18 +944,6 @@
 			shapes = shapeMergeFilter.merge(shapes);
 		}
 
-		// recalculate preserved status for all points in lines and shapes
-		shapes.forEach(e -> e.getPoints().forEach(p -> p.preserved(false)));
-		if (z.getLevel() == 0 && hasNet) {
-			lines.forEach(e -> e.getPoints().forEach(p -> p.preserved(p.isNumberNode())));	
-		} else {
-			lines.forEach(e -> e.getPoints().forEach(p -> p.preserved(false)));
-		}
-		preserveFirstLast(lines);
-		if (res < 24) {
-			preserveHorizontalAndVerticalLines(res, shapes);
-		}
-		
 		processLines(map, div, lines); 
 		processShapes(map, div, shapes);
 
